

本文為英文版的機器翻譯版本，如內容有任何歧義或不一致之處，概以英文版為準。

# 以程式設計方式下載 IDT
<a name="idt-programmatic-download-process"></a>

IDT 提供 API 操作，可讓您用來擷取 URL，以程式設計方式下載 IDT。您也可以使用此 API 操作來檢查您是否擁有最新版本的 IDT。此 API 操作具有下列端點。

```
https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt
```

若要呼叫此 API 操作，您必須具有執行 **iot-device-tester:LatestIdt**動作的許可。包含您的 AWS 簽章，以 `iot-device-tester`做為服務名稱

## API 請求
<a name="idt-programmatic-download-request"></a>

HostOs主機機器的作業系統。您可以從以下選項中選擇：  
+ `mac`
+ `linux`
+ `windows`

TestSuiteType – 測試套件的類型。選擇下列選項：  
`FR` – IDT for FreeRTOS

ProductVersion  
（選用） FreeRTOS 的版本。服務會傳回該 FreeRTOS 版本的最新相容 IDT 版本。如果您未指定此選項，服務會傳回最新版本的 IDT。

## API 回應
<a name="idt-programmatic-download-response"></a>

API 回應的格式如下。`DownloadURL` 包含 zip 檔案。

```
{
    "Success": {{True or False}},
    "Message": {{Message}},
    "LatestBk": {
        "Version": {{The version of the IDT binary}},
        "TestSuiteVersion": {{The version of the test suite}},
        "DownloadURL": {{The URL to download the IDT Bundle, valid for one hour}}
    }
 }
```

## 範例
<a name="idt-programmatic-download-examples"></a>

您可以參考下列範例以程式設計方式下載 IDT。這些範例使用您存放在 `AWS_ACCESS_KEY_ID`和 `AWS_SECRET_ACCESS_KEY`環境變數中的登入資料。若要遵循最佳安全實務，請勿將登入資料存放在程式碼中。

**Example**  
**範例：使用 cURL 7.75.0 版或更新版本 (Mac 和 Linux) 下載**  
如果您有 cURL 7.75.0 版或更新版本，您可以使用 `aws-sigv4`旗標來簽署 API 請求。此範例使用 [jq](https://stedolan.github.io/jq/) 從回應剖析下載 URL。  
`aws-sigv4` 旗標要求 curl GET 請求的查詢參數順序為 **HostOs/ProductVersion/TestSuiteType** 或 **HostOs/TestSuiteType**。不符合的順序將導致從 API Gateway 取得正式字串不相符簽章的錯誤。  
如果包含選用參數 **ProductVersion**，您必須使用支援的產品版本，如 [AWS IoT Device Tester FreeRTOS 的支援版本](https://docs.aws.amazon.com/freertos/latest/userguide/dev-test-versions-afr.html)中所述。
+ 將 {{us-west-2}} 取代為您的 AWS 區域。如需區域代碼清單，請參閱[區域端點](https://docs.aws.amazon.com/general/latest/gr/rande.html#regional-endpoints)。
+ 將 {{linux}} 取代為主機機器的作業系統。
+ 將 {{202107.00}} 取代為您的 FreeRTOS 版本。

```
url=$(curl --request GET "https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt?HostOs={{linux}}&ProductVersion={{202107.00}}&TestSuiteType=FR" \
--user $AWS_ACCESS_KEY_ID:$AWS_SECRET_ACCESS_KEY \
--aws-sigv4 "aws:amz:{{us-west-2}}:iot-device-tester" \
| jq -r '.LatestBk["DownloadURL"]')

curl $url --output devicetester.zip
```

**Example**  
**範例：使用舊版 cURL (Mac 和 Linux) 下載**  
您可以使用下列 cURL 命令搭配您簽署和計算的 AWS 簽章。如需如何簽署和計算 AWS 簽章的詳細資訊，請參閱[簽署 AWS API 請求](https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_sigv.html)。  
+ 將 {{linux}} 取代為主機機器的作業系統。
+ 將{{時間戳記}}取代為日期和時間，例如 **20220210T004606Z**。
+ 將{{日期}}取代為日期，例如 **20220210**。
+ 將 {{AWSRegion}} 取代為您的 AWS 區域。如需區域代碼清單，請參閱[區域端點](https://docs.aws.amazon.com/general/latest/gr/rande.html)。
+ 將 {{AWSSignature}} 取代為您產生的[AWS 簽章](https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_sigv-create-signed-request.html)。

```
curl --location --request GET 'https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt?HostOs={{linux}}&TestSuiteType=FR' \
--header 'X-Amz-Date: {{Timestamp}} \
--header 'Authorization: AWS4-HMAC-SHA256 Credential=$AWS_ACCESS_KEY_ID/{{Date}}/{{AWSRegion}}/iot-device-tester/aws4_request, SignedHeaders=host;x-amz-date, Signature={{AWSSignature}}'
```

**Example**  
**範例：使用 Python 指令碼下載**  
此範例使用 Python [請求](https://pypi.org/project/requests/)程式庫。此範例改編自 Python 範例，以在 *AWS * [一般參考中簽署 AWS API 請求](https://docs.aws.amazon.com/IAM/latest/UserGuide/reference_sigv.html)。    
  
+ 將 {{us-west-2}} 取代為您的區域。如需區域代碼清單，請參閱[區域端點](https://docs.aws.amazon.com/general/latest/gr/rande.html)。
+ 將 {{linux}} 取代為主機機器的作業系統。

```
# Copyright 2010-2022 Amazon.com, Inc. or its affiliates. All Rights Reserved.
#
# This file is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. A copy of the
#License is located at
#
# http://aws.amazon.com/apache2.0/
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
# OF ANY KIND, either express or implied. See the License for the specific
# language governing permissions and limitations under the License.

# See: http://docs.aws.amazon.com/general/latest/gr/sigv4_signing.html
# This version makes a GET request and passes the signature
# in the Authorization header.
import sys, os, base64, datetime, hashlib, hmac 
import requests # pip install requests
# ************* REQUEST VALUES *************
method = 'GET'
service = 'iot-device-tester'
host = 'download.devicetester.iotdevicesecosystem.amazonaws.com'
region = '{{us-west-2}}'
endpoint = 'https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt'
request_parameters = 'HostOs={{linux}}&TestSuiteType=FR'

# Key derivation functions. See:
# http://docs.aws.amazon.com/general/latest/gr/signature-v4-examples.html#signature-v4-examples-python
def sign(key, msg):
    return hmac.new(key, msg.encode('utf-8'), hashlib.sha256).digest()

def getSignatureKey(key, dateStamp, regionName, serviceName):
    kDate = sign(('AWS4' + key).encode('utf-8'), dateStamp)
    kRegion = sign(kDate, regionName)
    kService = sign(kRegion, serviceName)
    kSigning = sign(kService, 'aws4_request')
    return kSigning

# Read AWS access key from env. variables or configuration file. Best practice is NOT
# to embed credentials in code.
access_key = os.environ.get('AWS_ACCESS_KEY_ID')
secret_key = os.environ.get('AWS_SECRET_ACCESS_KEY')
if access_key is None or secret_key is None:
    print('No access key is available.')
    sys.exit()

# Create a date for headers and the credential string
t = datetime.datetime.utcnow()
amzdate = t.strftime('%Y%m%dT%H%M%SZ')
datestamp = t.strftime('%Y%m%d') # Date w/o time, used in credential scope

# ************* TASK 1: CREATE A CANONICAL REQUEST *************
# http://docs.aws.amazon.com/general/latest/gr/sigv4-create-canonical-request.html
# Step 1 is to define the verb (GET, POST, etc.)--already done.
# Step 2: Create canonical URI--the part of the URI from domain to query 
# string (use '/' if no path)
canonical_uri = '/latestidt' 
# Step 3: Create the canonical query string. In this example (a GET request),
# request parameters are in the query string. Query string values must
# be URL-encoded (space=%20). The parameters must be sorted by name.
# For this example, the query string is pre-formatted in the request_parameters variable.
canonical_querystring = request_parameters
# Step 4: Create the canonical headers and signed headers. Header names
# must be trimmed and lowercase, and sorted in code point order from
# low to high. Note that there is a trailing \n.
canonical_headers = 'host:' + host + '\n' + 'x-amz-date:' + amzdate + '\n'
# Step 5: Create the list of signed headers. This lists the headers
# in the canonical_headers list, delimited with ";" and in alpha order.
# Note: The request can include any headers; canonical_headers and
# signed_headers lists those that you want to be included in the 
# hash of the request. "Host" and "x-amz-date" are always required.
signed_headers = 'host;x-amz-date'
# Step 6: Create payload hash (hash of the request body content). For GET
# requests, the payload is an empty string ("").
payload_hash = hashlib.sha256(('').encode('utf-8')).hexdigest()
# Step 7: Combine elements to create canonical request
canonical_request = method + '\n' + canonical_uri + '\n' + canonical_querystring + '\n' + canonical_headers + '\n' + signed_headers + '\n' + payload_hash

# ************* TASK 2: CREATE THE STRING TO SIGN*************
# Match the algorithm to the hashing algorithm you use, either SHA-1 or
# SHA-256 (recommended)
algorithm = 'AWS4-HMAC-SHA256'
credential_scope = datestamp + '/' + region + '/' + service + '/' + 'aws4_request'
string_to_sign = algorithm + '\n' +  amzdate + '\n' +  credential_scope + '\n' +  hashlib.sha256(canonical_request.encode('utf-8')).hexdigest()
# ************* TASK 3: CALCULATE THE SIGNATURE *************
# Create the signing key using the function defined above.
signing_key = getSignatureKey(secret_key, datestamp, region, service)
# Sign the string_to_sign using the signing_key
signature = hmac.new(signing_key, (string_to_sign).encode('utf-8'), hashlib.sha256).hexdigest()

# ************* TASK 4: ADD SIGNING INFORMATION TO THE REQUEST *************
# The signing information can be either in a query string value or in 
# a header named Authorization. This code shows how to use a header.
# Create authorization header and add to request headers
authorization_header = algorithm + ' ' + 'Credential=' + access_key + '/' + credential_scope + ', ' +  'SignedHeaders=' + signed_headers + ', ' + 'Signature=' + signature
# The request can include any headers, but MUST include "host", "x-amz-date", 
# and (for this scenario) "Authorization". "host" and "x-amz-date" must
# be included in the canonical_headers and signed_headers, as noted
# earlier. Order here is not significant.
# Python note: The 'host' header is added automatically by the Python 'requests' library.
headers = {'x-amz-date':amzdate, 'Authorization':authorization_header}

# ************* SEND THE REQUEST *************
request_url = endpoint + '?' + canonical_querystring
print('\nBEGIN REQUEST++++++++++++++++++++++++++++++++++++')
print('Request URL = ' + request_url)
response = requests.get(request_url, headers=headers)
print('\nRESPONSE++++++++++++++++++++++++++++++++++++')
print('Response code: %d\n' % response.status_code)
print(response.text)

download_url = response.json()["LatestBk"]["DownloadURL"]
r = requests.get(download_url)
open('devicetester.zip', 'wb').write(r.content)
```